--[[

]]--

local addonName = ...
local addon = _G[addonName]

function createButtonMask_OnClick()
end

local function buildFrame()
   local frame
   
   if not frame then
      frame = addon.frame
   end
   
   local bkgrnd = frame:CreateTexture(nil, "BACKGROUND")
   bkgrnd:SetWidth(60)
   bkgrnd:SetHeight(60)
   bkgrnd:SetPoint("TOPLEFT", 7, -6)
      
   local dummyFont  = frame:CreateFontString("$parentDummyString", bkgrnd, "GameFontNormal")
   dummyFont:SetPoint("TOPLEFT")
   dummyFont:SetWidth(0)
   dummyFont:SetHeight(0)
   dummyFont:Hide()
      
   local topLeft = frame:CreateTexture(nil, "BORDER")
   topLeft:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopLeft")
   topLeft:SetPoint("TOPLEFT", frame, "TOPLEFT")

   local topRight = frame:CreateTexture(nil, "BORDER")
   topRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopRight")
   topRight:SetPoint("TOPRIGHT", frame, "TOPRIGHT")

   local botLeft = frame:CreateTexture(nil, "BORDER")
   botLeft:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-BotLeft")
   botLeft:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT")

   local botRight = frame:CreateTexture(nil, "BORDER")
   botRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-BotRight")
   botRight:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
      
   local title = frame:CreateFontString("SkillGuideFrameTitleText", "BORDER", "GameFontNormal")
   title:SetText("Skill Guide")
   title:SetPoint("TOP", frame, "TOP", 0, -17)
      
   local horBarLeft = frame:CreateTexture(nil, "ARTWORK")
   horBarLeft:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
   horBarLeft:SetWidth(256)
   horBarLeft:SetHeight(16)
   horBarLeft:SetPoint("TOPLEFT", 15, -221)
   horBarLeft:SetTexCoord(0, 1.0, 0, 0.25)
      
   local horBarRight = frame:CreateTexture(nil, "ARTWORK")
   horBarRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
   horBarRight:SetWidth(75)
   horBarRight:SetHeight(16)
   horBarRight:SetPoint("LEFT", horBarLeft, "RIGHT")
   horBarRight:SetTexCoord(0, 0.29296875, 0.25, 0.5)   
end

local function addButtons()
   local frame
   
   if not frame then
      frame = addon.frame
   end
   
   local cancelButton = CreateFrame("Button", "SkillGuideCancelButton", frame, "UIPanelButtonTemplate")
   cancelButton:SetWidth(80)
   cancelButton:SetHeight(22)
   cancelButton:SetPoint("CENTER", frame, "TOPLEFT", 305, -422)
   cancelButton:SetText("Exit")
   cancelButton:SetScript("OnClick", function() addon.frame:Hide() end)
   
   local createButton = CreateFrame("Button", "SkillGuideCreateButton", frame, "UIPanelButtonTemplate")
   createButton:SetWidth(80)
   createButton:SetHeight(22)
   createButton:SetPoint("CENTER", frame, "TOPLEFT", 224, -422)
   createButton:SetText("Create")
   createButton:SetScript("OnClick", function(self, button, down)
         if((not PartialPlayTime()) and (not NoPlayTime())) then
            DoTradeSkill(frame.selectedSkill, TradeSkillInputBox:GetNumber())
            TradeSkillInputBox:ClearFocus()
         end
   end)
   
   local createButtonMask = CreateFrame("Frame", "$parentMask", createButton)
   createButtonMask:SetAllPoints(createButton)
   createButtonMask:EnableMouse(true)
   createButtonMask:Hide()
   createButtonMask:SetScript("OnEnter", function()
      if(self.tooltip) then
         GameTooltip:SetOwner(self, "ANCHOR_LEFT")
         GameTooltip:SetText(self.tooltip, nil, nil, nil, nil, 1)
      end
   end)
   createButtonMask:SetScript("OnLeave", function() GameTooltip:Hide() end)
   
   local createAllButton = CreateFrame("Button", "SkillGuideCreateAllButton", frame, "UIPanelButtonTemplate")
   createAllButton:SetWidth(80)
   createAllButton:SetHeight(22)
   createAllButton:SetPoint("RIGHT", createButton, "LEFT", -86, 0)
   createAllButton:SetText("Create All")
   createAllButton:SetScript("OnClick", function(self, button, down)
      if((not PartialPlayTime()) and (not NoPlayTime())) then
         TradeSkillInputBox:SetNumber(frame.numAvailable)
         DoTradeSkill(frame.selectedSkill, frame.numAvailable)
         TradeSkillInputBox:ClearFocus()
      end
   end)
   
   local createAllButtonMask = CreateFrame("Frame", "$parentMask", createAllButton)
   createAllButtonMask:SetAllPoints(createAllButton)
   createAllButtonMask:EnableMouse(true)
   createAllButtonMask:Hide()
   createAllButtonMask:SetScript("OnEnter", function()
      if(self.tooltip) then
         GameTooltip:SetOwner(self, "ANCHOR_LEFT")
         GameTooltip:SetText(self.tooltip, nil, nil, nil, nil, 1)
      end
   end)
   createAllButtonMask:SetScript("OnLeave", function() GameTooltip:Hide() end)
   
end

function addon:InitFrame()
   local frame
   
   -- Check if the main frame has been created before
   if not addon.frame then
      addon.frame = CreateFrame("Frame", "SkillGuideFrame", UIParent)
      frame = addon.frame
   end
   
   -- Get the created frame
   if not frame then
      frame = addon.frame
   end
   
   frame:SetWidth(384)
   frame:SetHeight(512)
   frame:SetPoint("TOPLEFT", 394, -104)
   
   frame:SetFrameStrata("MEDIUM")
   
   frame:SetToplevel(true)
   frame:SetMovable(true)
   frame:EnableMouse(true)
   frame:SetClampedToScreen(true)
   
   frame:SetClampRectInsets(0, -35, 0, 75)
   frame:SetHitRectInsets(0, 34, 0, 75)
   
   tinsert(UISpecialFrames, "SkillGuideFrame")

   buildFrame()
   
   addButtons()
   
   frame:Hide()
end